/* 
The code albeit hard coded uses the livelink java api combined 
for getting task related info
In this example execute the Live report All late workflows
Written in answer for an functional_nam query in livelink Knowledge Base
tested java version "1.3.1_02"
Java(TM) 2 Runtime Environment, Standard Edition (build 1.3.1_02-b02)
OJVM Client VM (build 9.0.2.572 cdov, Copyright (c) 1998-2002  Oracle Corp., nojit)
Simple live report execution list does not have any input  paras
<!-- File: report/batchexport2.html -->
All Late Workflows=A<1,?,'conf_names'='','conf_values'='',
'displaytype'='autoreport','fields'={'Work_WorkID','SubWork_Title',
'SubWork_DateDue_Max'},'headers'={X<REPORT_IMPCOLUMNLABEL.WorkflowID>,
X<REPORT_IMPCOLUMNLABEL.WorkflowName>,X<REPORT_IMPCOLUMNLABEL.DueDate>},
'inputs'={},'oldDataId'=2035,'params'={'#Time:Today-Now',?,?,?,?,?,?,?,?,?},
'recordlimit'=100,'sql'='SELECT A.Work_WorkID, A.SubWork_Title,
 A.SubWork_DateDue_Max FROM WebActiveWork A WHERE 
( A.Work_DateDue_Max IS NOT NULL AND A.Work_DateDue_Max < %1 )
 OR ( A.SubWork_DateDue_Max IS NOT NULL AND A.SubWork_DateDue_Max < %1 )',
'subreport_id'=?,'subreport_parms'={},'subreport_path'='',
'Title'=X<REPORT_IMPTITLE.AllLateWorkflows>>
<!-- End File: report/batchexport2.html -->
@author K N Nair (appoos@hotmail.com) alias appnair/samalayali 
kn_nair@ssa-sa.sel.sony.com in tektips
Acknowledgement  for using printTypeTree as a helper function
Fantastic object tree traversal
Glenn Heying (SCorUser8) Department: Sprint Corporate
SPRINT01 Title: Systems Developer V 
E-mail: glenn.heying@mail.sprint.com Phone: (816) 665-9626
*/                                         



//to get task related items
import java.util.*;//for our date manip
import com.opentext.api.*;
public class RunSimpleReport{
	private static String Server = "localhost"; //livelink host
	private static int Port = 5555; //livelink server port see opentext.ini
	private static String DFT = ""; //default database file or schema
	private static String User = "Admin"; //username
	private static String Pass = "123admin"; //passwd
         
	public static void main (String [] args)
	{
		try
		{
			//variables
			LLSession session;
                  LAPI_DOCUMENTS doc;
			session = new LLSession (Server, Port, DFT, User, Pass);
			doc = new LAPI_DOCUMENTS (session);
                  LLValue LLvalueGetLiveReport=new LLValue().setAssocNotSet();
                  //To execute a live report you need a list
                  LLValue LLvalueInputs=new LLValue().setList();
                  LLValue LLvalueOutputs=new LLValue().setAssocNotSet();
	            int volID, objID,versionID;
			volID = -2000;//Parent VolumeID usually enterprise workspace use accessenterprise if you do not like hardcoding
			objID = 12225;//unique number of Live report
			if (doc.GetObjectInfo(volID,objID,LLvalueGetLiveReport) == 0)
			{
		      	System.out.println("Live report Object found");
                        int CreatedBy =-LLvalueGetLiveReport.toInteger("CreatedBy");
                        int CacheExpiration=-LLvalueGetLiveReport.toInteger("CacheExpiration");
                        Date CreateDate= LLvalueGetLiveReport.toDate("CreateDate");
                        int length = LLvalueGetLiveReport.size();
                        int whatIsIt=LLvalueGetLiveReport.type();
                      //uncomment this if you would like to see the whole
                      //output tree of object
                      // printTypeTree(LLvalueGetLiveReport,"|"," ");
                     
                     if(doc.RunReport(volID,objID,LLvalueInputs,LLvalueOutputs)==0)
                        {
                        System.out.println("Success"); 
                        printTypeTree(LLvalueOutputs,"|"," ");
                        }
                       else
                          {
                        System.out.println("Failed"); 
                        System.out.println("Status Code: " + session.getStatus());
				System.out.println("Api Error: " + session.getApiError());
				System.out.println("Error Message: " + session.getErrMsg());
				System.out.println("Status Message: " + session.getStatusMessage());
                           } 			
                        
                    


                  }
              
	            
			else
			{
				System.out.println("Failed to execute Document");
				//Error Checking
				System.out.println("Status Code: " + session.getStatus());
				System.out.println("Api Error: " + session.getApiError());
				System.out.println("Error Message: " + session.getErrMsg());
				System.out.println("Status Message: " + session.getStatusMessage());
			}


		}
		catch (Throwable e)
		{
			System.err.println(e.getMessage() );
			e.printStackTrace (System.err);
		}
	}



//Helper class which was published by another 
//user in the LAPI discussion
private static void printTypeTree(LLValue inVal, String szSep, String szName) {
		System.out.println(szSep + szName + " - " + printLLValueType(inVal.type()) + "\t" + printLLValue(inVal));
		if(inVal.type() == LLValue.LL_ASSOC ||
				inVal.type() == LLValue.LL_RECORD ||
				inVal.type() == LLValue.LL_TABLE) {
			LLNameEnumeration enumValue;
			enumValue = inVal.enumerateNames();
			while(enumValue.hasMoreElements()) {
				String elValue = enumValue.nextElement().toString();
				printTypeTree(inVal.toValue(elValue), "\t" + szSep, elValue);
			}
		}
		else {
			if(inVal.type() == LLValue.LL_LIST) {
				for(int i = 0; i < inVal.size(); i++) {
					printTypeTree(inVal.toValue(i), "\t" + szSep, "" + i);
				}
			}
		}
	}

	private static String printLLValue(LLValue llVal)
	{
		String returnString = "";

		switch (llVal.type()) {
		case LLValue.LL_BOOLEAN :
			returnString = "" + llVal.toBoolean();
			break;
		case LLValue.LL_DATE :
			returnString = llVal.toDate().toString();
			break;
		case LLValue.LL_DOUBLE :
			returnString = "" + llVal.toDouble();
			break;
		case LLValue.LL_INTEGER :
			returnString = "" + llVal.toInteger();
			break;
		case LLValue.LL_STRING :
			returnString = llVal.toString();
			break;
		default :
			break;
		}
		return returnString;
	}

	private static String printLLValueType(int iType) {
		String returnString = " ";
		switch (iType) {
		case LLValue.LL_ASSOC :
			returnString = "Type is ASSOC";
			break;
		case LLValue.LL_BOOLEAN :
			returnString = "Type is BOOLEAN";
			break;
		case LLValue.LL_DATE :
			returnString = "Type is DATE";
			break;
		case LLValue.LL_DOUBLE :
			returnString = "Type is DOUBLE";
			break;
		case LLValue.LL_ERROR :
			returnString = "Type is ERROR";
			break;
		case LLValue.LL_INTEGER :
			returnString = "Type is INTEGER";
			break;
		case LLValue.LL_LIST :
			returnString = "Type is LIST";
			break;
		case LLValue.LL_NOTSET :
			returnString = "Type is NOTSET";
			break;
		case LLValue.LL_RECORD :
			returnString = "Type is RECORD";
			break;
		case LLValue.LL_STRING :
			returnString = "Type is STRING";
			break;
		case LLValue.LL_TABLE :
			returnString = "Type is TABLE";
			break;
		case LLValue.LL_UNDEFINED :
			returnString = "Type is UNDEFINED";
			break;
		default :
			returnString = "Type is Unknown";
			break;
		}
		return returnString;
	}//helper method ends



	

}//class ends here